<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!--NewPage-->
<HTML>
<HEAD>
<!-- Generated by javadoc (build 1.5.0_06) on Wed Aug 20 17:16:46 PDT 2008 -->
<TITLE>
com.google.common.collect (Google Collections Library - snapshot-20080820 (ALPHA))
</TITLE>

<META NAME="keywords" CONTENT="com.google.common.collect package">

<LINK REL ="stylesheet" TYPE="text/css" HREF="../../../../stylesheet.css" TITLE="Style">

<SCRIPT type="text/javascript">
function windowTitle()
{
    parent.document.title="com.google.common.collect (Google Collections Library - snapshot-20080820 (ALPHA))";
}
</SCRIPT>
<NOSCRIPT>
</NOSCRIPT>

</HEAD>

<BODY BGCOLOR="white" onload="windowTitle();">


<!-- ========= START OF TOP NAVBAR ======= -->
<A NAME="navbar_top"><!-- --></A>
<A HREF="#skip-navbar_top" title="Skip navigation links"></A>
<TABLE BORDER="0" WIDTH="100%" CELLPADDING="1" CELLSPACING="0" SUMMARY="">
<TR>
<TD COLSPAN=2 BGCOLOR="#EEEEFF" CLASS="NavBarCell1">
<A NAME="navbar_top_firstrow"><!-- --></A>
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="3" SUMMARY="">
  <TR ALIGN="center" VALIGN="top">
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../overview-summary.html"><FONT CLASS="NavBarFont1"><B>Overview</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#FFFFFF" CLASS="NavBarCell1Rev"> &nbsp;<FONT CLASS="NavBarFont1Rev"><B>Package</B></FONT>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <FONT CLASS="NavBarFont1">Class</FONT>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-tree.html"><FONT CLASS="NavBarFont1"><B>Tree</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../deprecated-list.html"><FONT CLASS="NavBarFont1"><B>Deprecated</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../index-all.html"><FONT CLASS="NavBarFont1"><B>Index</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../help-doc.html"><FONT CLASS="NavBarFont1"><B>Help</B></FONT></A>&nbsp;</TD>
  </TR>
</TABLE>
</TD>
<TD ALIGN="right" VALIGN="top" ROWSPAN=3><EM>
</EM>
</TD>
</TR>

<TR>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
&nbsp;<A HREF="../../../../com/google/common/base/package-summary.html"><B>PREV PACKAGE</B></A>&nbsp;
&nbsp;NEXT PACKAGE</FONT></TD>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
  <A HREF="../../../../index.html?com/google/common/collect/package-summary.html" target="_top"><B>FRAMES</B></A>  &nbsp;
&nbsp;<A HREF="package-summary.html" target="_top"><B>NO FRAMES</B></A>  &nbsp;
&nbsp;<SCRIPT type="text/javascript">
  <!--
  if(window==top) {
    document.writeln('<A HREF="../../../../allclasses-noframe.html"><B>All Classes</B></A>');
  }
  //-->
</SCRIPT>
<NOSCRIPT>
  <A HREF="../../../../allclasses-noframe.html"><B>All Classes</B></A>
</NOSCRIPT>


</FONT></TD>
</TR>
</TABLE>
<A NAME="skip-navbar_top"></A>
<!-- ========= END OF TOP NAVBAR ========= -->

<HR>
<H2>
Package com.google.common.collect
</H2>
This package contains generic collection interfaces and implementations, and
 other utilities for working with collections.
<P>
<B>See:</B>
<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<A HREF="#package_description"><B>Description</B></A>
<P>

<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="2"><FONT SIZE="+2">
<B>Interface Summary</B></FONT></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/BiMap.html" title="interface in com.google.common.collect">BiMap&lt;K,V&gt;</A></B></TD>
<TD>A bimap (or "bidirectional map") is a map that preserves the uniqueness of
 its values as well as that of its keys.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/ClassToInstanceMap.html" title="interface in com.google.common.collect">ClassToInstanceMap&lt;B&gt;</A></B></TD>
<TD>A map, each entry of which maps a Java
 <a href="http://tinyurl.com/2cmwkz">raw type</a> to an instance of that type.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/Constraint.html" title="interface in com.google.common.collect">Constraint&lt;E&gt;</A></B></TD>
<TD>A constraint that an element must satisfy in order to be added to a
 collection.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/ListMultimap.html" title="interface in com.google.common.collect">ListMultimap&lt;K,V&gt;</A></B></TD>
<TD>A <code>Multimap</code> that can hold duplicate key-value pairs and that maintains
 the insertion ordering of values for a given key.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/MapConstraint.html" title="interface in com.google.common.collect">MapConstraint&lt;K,V&gt;</A></B></TD>
<TD>A constraint on the keys and values that may be added to a <code>Map</code> or
 <code>Multimap</code>.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/Multimap.html" title="interface in com.google.common.collect">Multimap&lt;K,V&gt;</A></B></TD>
<TD>A collection similar to a <code>Map</code>, but which may associate multiple
 values with a single key.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/Multiset.html" title="interface in com.google.common.collect">Multiset&lt;E&gt;</A></B></TD>
<TD>A collection that supports order-independent equality, like <A HREF="http://java.sun.com/javase/6/docs/api/java/util/Set.html" title="class or interface in java.util"><CODE>Set</CODE></A>, but
 may have duplicate elements.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/Multiset.Entry.html" title="interface in com.google.common.collect">Multiset.Entry&lt;E&gt;</A></B></TD>
<TD>An unmodifiable element-count pair for a multiset.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/PeekingIterator.html" title="interface in com.google.common.collect">PeekingIterator&lt;E&gt;</A></B></TD>
<TD>An iterator that supports a one-element lookahead while iterating.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/SetMultimap.html" title="interface in com.google.common.collect">SetMultimap&lt;K,V&gt;</A></B></TD>
<TD>A <code>Multimap</code> that cannot hold duplicate key-value pairs.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/SortedSetMultimap.html" title="interface in com.google.common.collect">SortedSetMultimap&lt;K,V&gt;</A></B></TD>
<TD>A <code>SetMultimap</code> whose set of values for a given key are kept sorted;
 that is, they comprise a <A HREF="http://java.sun.com/javase/6/docs/api/java/util/SortedSet.html" title="class or interface in java.util"><CODE>SortedSet</CODE></A>.</TD>
</TR>
</TABLE>
&nbsp;

<P>

<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="2"><FONT SIZE="+2">
<B>Class Summary</B></FONT></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/AbstractIterable.html" title="class in com.google.common.collect">AbstractIterable&lt;E&gt;</A></B></TD>
<TD>Provides an implementation of <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html#toString()" title="class or interface in java.lang"><CODE>Object.toString()</CODE></A> for <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Iterable.html" title="class or interface in java.lang"><CODE>Iterable</CODE></A>
 instances.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/AbstractIterator.html" title="class in com.google.common.collect">AbstractIterator&lt;T&gt;</A></B></TD>
<TD>This class provides a skeletal implementation of the <code>Iterator</code>
 interface, to make this interface easier to implement for certain types of
 data sources.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/AbstractMapEntry.html" title="class in com.google.common.collect">AbstractMapEntry&lt;K,V&gt;</A></B></TD>
<TD>Implementation of the <code>equals</code>, <code>hashCode</code>, and <code>toString</code>
 methods of <code>Entry</code>.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/AbstractMultiset.html" title="class in com.google.common.collect">AbstractMultiset&lt;E&gt;</A></B></TD>
<TD>This class provides a skeletal implementation of the <A HREF="../../../../com/google/common/collect/Multiset.html" title="interface in com.google.common.collect"><CODE>Multiset</CODE></A>
 interface.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/AbstractMultisetEntry.html" title="class in com.google.common.collect">AbstractMultisetEntry&lt;E&gt;</A></B></TD>
<TD>Implementation of the <code>equals</code>, <code>hashCode</code>, and <code>toString</code>
 methods of <A HREF="../../../../com/google/common/collect/Multiset.Entry.html" title="interface in com.google.common.collect"><CODE>Multiset.Entry</CODE></A>.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/AbstractRemovableIterator.html" title="class in com.google.common.collect">AbstractRemovableIterator&lt;T&gt;</A></B></TD>
<TD>A specialization of <code>AbstractIterator</code> for data sources which can
 handle arbitrary removal by element, concurrently with iteration.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/ArrayListMultimap.html" title="class in com.google.common.collect">ArrayListMultimap&lt;K,V&gt;</A></B></TD>
<TD>Implementation of <code>Multimap</code> that uses an <code>ArrayList</code> to store
 the values for a given key.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/Collections2.html" title="class in com.google.common.collect">Collections2</A></B></TD>
<TD>Provides static methods for working with <code>Collection</code> instances.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/Comparators.html" title="class in com.google.common.collect">Comparators</A></B></TD>
<TD>Standard comparators and utilities for creating and working with comparators.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/ConcurrentMultiset.html" title="class in com.google.common.collect">ConcurrentMultiset&lt;E&gt;</A></B></TD>
<TD>A multiset that supports concurrent modifications and that provides atomic
 versions of most <code>Multiset</code> operations (exceptions where noted).</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/Constraints.html" title="class in com.google.common.collect">Constraints</A></B></TD>
<TD>Factories and utilities pertaining to the <A HREF="../../../../com/google/common/collect/Constraint.html" title="interface in com.google.common.collect"><CODE>Constraint</CODE></A> interface.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/EnumBiMap.html" title="class in com.google.common.collect">EnumBiMap&lt;K extends Enum&lt;K&gt;,V extends Enum&lt;V&gt;&gt;</A></B></TD>
<TD>A <code>BiMap</code> backed by two <code>EnumMap</code> instances.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/EnumHashBiMap.html" title="class in com.google.common.collect">EnumHashBiMap&lt;K extends Enum&lt;K&gt;,V&gt;</A></B></TD>
<TD>A <code>BiMap</code> backed by an <code>EnumMap</code> instance for keys-to-values, and
 a <code>HashMap</code> instance for values-to-keys.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/EnumMultiset.html" title="class in com.google.common.collect">EnumMultiset&lt;E extends Enum&lt;E&gt;&gt;</A></B></TD>
<TD>Multiset implementation backed by an <A HREF="http://java.sun.com/javase/6/docs/api/java/util/EnumMap.html" title="class or interface in java.util"><CODE>EnumMap</CODE></A>.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/ForwardingCollection.html" title="class in com.google.common.collect">ForwardingCollection&lt;E&gt;</A></B></TD>
<TD>A collection which forwards all its method calls to another collection.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/ForwardingConcurrentMap.html" title="class in com.google.common.collect">ForwardingConcurrentMap&lt;K,V&gt;</A></B></TD>
<TD>A concurrent map which forwards all its method calls to another concurrent
 map.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/ForwardingIterator.html" title="class in com.google.common.collect">ForwardingIterator&lt;T&gt;</A></B></TD>
<TD>An iterator which forwards all its method calls to another iterator.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/ForwardingList.html" title="class in com.google.common.collect">ForwardingList&lt;E&gt;</A></B></TD>
<TD>A list which forwards all its method calls to another list.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/ForwardingListIterator.html" title="class in com.google.common.collect">ForwardingListIterator&lt;E&gt;</A></B></TD>
<TD>A list iterator which forwards all its method calls to another list
 iterator.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/ForwardingMap.html" title="class in com.google.common.collect">ForwardingMap&lt;K,V&gt;</A></B></TD>
<TD>A map which forwards all its method calls to another map.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/ForwardingMapEntry.html" title="class in com.google.common.collect">ForwardingMapEntry&lt;K,V&gt;</A></B></TD>
<TD>A map entry which forwards all its method calls to another map entry.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/ForwardingMultimap.html" title="class in com.google.common.collect">ForwardingMultimap&lt;K,V&gt;</A></B></TD>
<TD>A multimap which forwards all its method calls to another multimap.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/ForwardingMultiset.html" title="class in com.google.common.collect">ForwardingMultiset&lt;E&gt;</A></B></TD>
<TD>A multiset which forwards all its method calls to another multiset.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/ForwardingObject.html" title="class in com.google.common.collect">ForwardingObject</A></B></TD>
<TD>An abstract base class for implementing the <a
 href="http://en.wikipedia.org/wiki/Decorator_pattern">decorator pattern</a>.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/ForwardingQueue.html" title="class in com.google.common.collect">ForwardingQueue&lt;E&gt;</A></B></TD>
<TD>A queue which forwards all its method calls to another queue.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/ForwardingSet.html" title="class in com.google.common.collect">ForwardingSet&lt;E&gt;</A></B></TD>
<TD>A set which forwards all its method calls to another set.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/ForwardingSortedMap.html" title="class in com.google.common.collect">ForwardingSortedMap&lt;K,V&gt;</A></B></TD>
<TD>A sorted map which forwards all its method calls to another sorted map.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/ForwardingSortedSet.html" title="class in com.google.common.collect">ForwardingSortedSet&lt;E&gt;</A></B></TD>
<TD>A sorted set which forwards all its method calls to another sorted set.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/HashBiMap.html" title="class in com.google.common.collect">HashBiMap&lt;K,V&gt;</A></B></TD>
<TD>A <A HREF="../../../../com/google/common/collect/BiMap.html" title="interface in com.google.common.collect"><CODE>BiMap</CODE></A> backed by two <A HREF="http://java.sun.com/javase/6/docs/api/java/util/HashMap.html" title="class or interface in java.util"><CODE>HashMap</CODE></A> instances.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/HashMultimap.html" title="class in com.google.common.collect">HashMultimap&lt;K,V&gt;</A></B></TD>
<TD>Implementation of <A HREF="../../../../com/google/common/collect/Multimap.html" title="interface in com.google.common.collect"><CODE>Multimap</CODE></A> using hash tables.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/HashMultiset.html" title="class in com.google.common.collect">HashMultiset&lt;E&gt;</A></B></TD>
<TD>Multiset implementation backed by a <A HREF="http://java.sun.com/javase/6/docs/api/java/util/HashMap.html" title="class or interface in java.util"><CODE>HashMap</CODE></A>.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/ImmutableBiMap.html" title="class in com.google.common.collect">ImmutableBiMap&lt;K,V&gt;</A></B></TD>
<TD>An immutable <A HREF="../../../../com/google/common/collect/BiMap.html" title="interface in com.google.common.collect"><CODE>BiMap</CODE></A> with reliable user-specified iteration order.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/ImmutableBiMap.Builder.html" title="class in com.google.common.collect">ImmutableBiMap.Builder&lt;K,V&gt;</A></B></TD>
<TD>A builder for creating immutable bimap instances, especially <code>public
 static final</code> bimaps ("constant bimaps").</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/ImmutableCollection.html" title="class in com.google.common.collect">ImmutableCollection&lt;E&gt;</A></B></TD>
<TD>An immutable collection.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/ImmutableList.html" title="class in com.google.common.collect">ImmutableList&lt;E&gt;</A></B></TD>
<TD>A high-performance, immutable, random-access <code>List</code> implementation.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/ImmutableMap.html" title="class in com.google.common.collect">ImmutableMap&lt;K,V&gt;</A></B></TD>
<TD>An immutable, hash-based <A HREF="http://java.sun.com/javase/6/docs/api/java/util/Map.html" title="class or interface in java.util"><CODE>Map</CODE></A> with reliable user-specified iteration
 order.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/ImmutableMap.Builder.html" title="class in com.google.common.collect">ImmutableMap.Builder&lt;K,V&gt;</A></B></TD>
<TD>A builder for creating immutable map instances, especially <code>public
 static final</code> maps ("constant maps").</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/ImmutableMultimap.html" title="class in com.google.common.collect">ImmutableMultimap&lt;K,V&gt;</A></B></TD>
<TD>An immutable <A HREF="../../../../com/google/common/collect/ListMultimap.html" title="interface in com.google.common.collect"><CODE>ListMultimap</CODE></A> with reliable user-specified key and value
 iteration order.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/ImmutableMultimap.Builder.html" title="class in com.google.common.collect">ImmutableMultimap.Builder&lt;K,V&gt;</A></B></TD>
<TD>A builder for creating immutable multimap instances, especially
 <code>public static final</code> multimaps ("constant multimaps").</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/ImmutableMultiset.html" title="class in com.google.common.collect">ImmutableMultiset&lt;E&gt;</A></B></TD>
<TD>An immutable hash-based multiset.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/ImmutableSet.html" title="class in com.google.common.collect">ImmutableSet&lt;E&gt;</A></B></TD>
<TD>A high-performance, immutable <code>Set</code> with reliable, user-specified
 iteration order.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/ImmutableSortedSet.html" title="class in com.google.common.collect">ImmutableSortedSet&lt;E&gt;</A></B></TD>
<TD>An immutable <code>SortedSet</code> that stores its elements in a sorted array.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/ImmutableSortedSet.Factory.html" title="class in com.google.common.collect">ImmutableSortedSet.Factory&lt;E&gt;</A></B></TD>
<TD>A factory for creating immutable sorted sets with an explicit comparator.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/Iterables.html" title="class in com.google.common.collect">Iterables</A></B></TD>
<TD>This class contains static utility methods that operate on or return objects
 of type <code>Iterable</code>.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/Iterators.html" title="class in com.google.common.collect">Iterators</A></B></TD>
<TD>This class contains static utility methods that operate on or return objects
 of type <code>Iterator</code>.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/LinkedHashMultimap.html" title="class in com.google.common.collect">LinkedHashMultimap&lt;K,V&gt;</A></B></TD>
<TD>Implementation of <code>Multimap</code> that does not allow duplicate key-value
 entries and that returns collections whose iterators follow the ordering in
 which the data was added to the multimap.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/LinkedHashMultiset.html" title="class in com.google.common.collect">LinkedHashMultiset&lt;E&gt;</A></B></TD>
<TD>A <code>Multiset</code> implementation with predictable iteration order.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/Lists.html" title="class in com.google.common.collect">Lists</A></B></TD>
<TD>Static utility methods pertaining to <A HREF="http://java.sun.com/javase/6/docs/api/java/util/List.html" title="class or interface in java.util"><CODE>List</CODE></A> instances.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/MapConstraints.html" title="class in com.google.common.collect">MapConstraints</A></B></TD>
<TD>Factory and utilities pertaining to the <code>MapConstraint</code> interface.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/Maps.html" title="class in com.google.common.collect">Maps</A></B></TD>
<TD>Static utility methods pertaining to <A HREF="http://java.sun.com/javase/6/docs/api/java/util/Map.html" title="class or interface in java.util"><CODE>Map</CODE></A> instances.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/Multimaps.html" title="class in com.google.common.collect">Multimaps</A></B></TD>
<TD>Provides static methods acting on or generating a <code>Multimap</code>.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/Multisets.html" title="class in com.google.common.collect">Multisets</A></B></TD>
<TD>Provides static utility methods for creating and working with <A HREF="../../../../com/google/common/collect/Multiset.html" title="interface in com.google.common.collect"><CODE>Multiset</CODE></A> instances.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/ObjectArrays.html" title="class in com.google.common.collect">ObjectArrays</A></B></TD>
<TD>Static utility methods pertaining to object arrays.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/Ordering.html" title="class in com.google.common.collect">Ordering&lt;T&gt;</A></B></TD>
<TD>A base class for <A HREF="http://java.sun.com/javase/6/docs/api/java/io/Serializable.html" title="class or interface in java.io"><CODE>Serializable</CODE></A> <A HREF="http://java.sun.com/javase/6/docs/api/java/util/Comparator.html" title="class or interface in java.util"><CODE>comparators</CODE></A> that
 provides convenience methods for common uses.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/PrimitiveArrays.html" title="class in com.google.common.collect">PrimitiveArrays</A></B></TD>
<TD>Static utility methods pertaining to arrays of Java primitives.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="class in com.google.common.collect">ReferenceMap&lt;K,V&gt;</A></B></TD>
<TD>A <code>ConcurrentMap</code> implementation that internally utilizes your choice
 of strong, soft or weak references for its keys and for its values.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/Serialization.html" title="class in com.google.common.collect">Serialization</A></B></TD>
<TD>Provides static method for serializing collection classes.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/Sets.html" title="class in com.google.common.collect">Sets</A></B></TD>
<TD>Static utility methods pertaining to <A HREF="http://java.sun.com/javase/6/docs/api/java/util/Set.html" title="class or interface in java.util"><CODE>Set</CODE></A> instances.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/Sets.SetView.html" title="class in com.google.common.collect">Sets.SetView&lt;E&gt;</A></B></TD>
<TD>An unmodifiable view of a set which may be backed by other sets; this view
 will change as the backing sets do.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/TreeMultimap.html" title="class in com.google.common.collect">TreeMultimap&lt;K,V&gt;</A></B></TD>
<TD>Implementation of <code>Multimap</code> whose keys and values are ordered by their
 natural ordering or by supplied comparators.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/TreeMultiset.html" title="class in com.google.common.collect">TreeMultiset&lt;E&gt;</A></B></TD>
<TD>Multiset implementation backed by a <code>TreeMap</code>.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../com/google/common/collect/UnmodifiableIterator.html" title="class in com.google.common.collect">UnmodifiableIterator&lt;E&gt;</A></B></TD>
<TD>An iterator that does not support <A HREF="../../../../com/google/common/collect/UnmodifiableIterator.html#remove()"><CODE>remove()</CODE></A>.</TD>
</TR>
</TABLE>
&nbsp;

<P>
<A NAME="package_description"><!-- --></A><H2>
Package com.google.common.collect Description
</H2>

<P>
This package contains generic collection interfaces and implementations, and
 other utilities for working with collections.

 <h2>Collection Types</h2>

 <dl>
 <dt><A HREF="../../../../com/google/common/collect/BiMap.html" title="interface in com.google.common.collect"><CODE>BiMap</CODE></A>
 <dd>An extension of <A HREF="http://java.sun.com/javase/6/docs/api/java/util/Map.html" title="class or interface in java.util"><CODE>Map</CODE></A> that guarantees the uniqueness of
     its values as well as that of its keys. This is sometimes called an
     "invertible map," since the restriction on values enables it to support
     an <A HREF="../../../../com/google/common/collect/BiMap.html#inverse()">inverse view</A> --
     which is another instance of <code>BiMap</code>.

 <dt><A HREF="../../../../com/google/common/collect/Multiset.html" title="interface in com.google.common.collect"><CODE>Multiset</CODE></A>
 <dd>An extension of <A HREF="http://java.sun.com/javase/6/docs/api/java/util/Collection.html" title="class or interface in java.util"><CODE>Collection</CODE></A> that may contain duplicate
     values like a <A HREF="http://java.sun.com/javase/6/docs/api/java/util/List.html" title="class or interface in java.util"><CODE>List</CODE></A>, yet has order-independent equality
     like a <A HREF="http://java.sun.com/javase/6/docs/api/java/util/Set.html" title="class or interface in java.util"><CODE>Set</CODE></A>.  One typical use for a multiset is to
     represent a histogram.

 <dt><A HREF="../../../../com/google/common/collect/Multimap.html" title="interface in com.google.common.collect"><CODE>Multimap</CODE></A>
 <dd>A new type, which is similar to <A HREF="http://java.sun.com/javase/6/docs/api/java/util/Map.html" title="class or interface in java.util"><CODE>Map</CODE></A>, but may contain
     multiple entries with the same key. Some behaviors of
     <A HREF="../../../../com/google/common/collect/Multimap.html" title="interface in com.google.common.collect"><CODE>Multimap</CODE></A> are left unspecified and are
     provided only by the subtypes mentioned below.

 <dt><A HREF="../../../../com/google/common/collect/SetMultimap.html" title="interface in com.google.common.collect"><CODE>SetMultimap</CODE></A>
 <dd>An extension of <A HREF="../../../../com/google/common/collect/Multimap.html" title="interface in com.google.common.collect"><CODE>Multimap</CODE></A> which has
     order-independent equality and does not allow duplicate entries; that is,
     while a key may appear twice in a <code>SetMultimap</code>, each must map to a
     different value.  <code>SetMultimap</code> takes its name from the fact that
     the <A HREF="../../../../com/google/common/collect/SetMultimap.html#get(K)">collection of
     values</A> associated with a given key fulfills the <A HREF="http://java.sun.com/javase/6/docs/api/java/util/Set.html" title="class or interface in java.util"><CODE>Set</CODE></A>
     contract.

 <dt><A HREF="../../../../com/google/common/collect/ListMultimap.html" title="interface in com.google.common.collect"><CODE>ListMultimap</CODE></A>
 <dd>An extension of <A HREF="../../../../com/google/common/collect/Multimap.html" title="interface in com.google.common.collect"><CODE>Multimap</CODE></A> which permits
     duplicate entries, supports random access of values for a particular key,
     and has <i>partially order-dependent equality</i> as defined by
     <A HREF="../../../../com/google/common/collect/ListMultimap.html#equals(java.lang.Object)"><CODE>ListMultimap.equals(Object)</CODE></A>. <code>ListMultimap</code> takes its name from the fact that the <A HREF="../../../../com/google/common/collect/ListMultimap.html#get(K)">collection of values</A>
     associated with a given key fulfills the <A HREF="http://java.sun.com/javase/6/docs/api/java/util/List.html" title="class or interface in java.util"><CODE>List</CODE></A> contract.

 <dt><A HREF="../../../../com/google/common/collect/SortedSetMultimap.html" title="interface in com.google.common.collect"><CODE>SortedSetMultimap</CODE></A>
 <dd>An extension of <A HREF="../../../../com/google/common/collect/SetMultimap.html" title="interface in com.google.common.collect"><CODE>SetMultimap</CODE></A> for which
     the <A HREF="../../../../com/google/common/collect/SortedSetMultimap.html#get(K)">collection values</A> associated with a given key is a
     <A HREF="http://java.sun.com/javase/6/docs/api/java/util/SortedSet.html" title="class or interface in java.util"><CODE>SortedSet</CODE></A>.

 <dt><A HREF="../../../../com/google/common/collect/ClassToInstanceMap.html" title="interface in com.google.common.collect"><CODE>ClassToInstanceMap</CODE></A>
 <dd>An extension of <A HREF="http://java.sun.com/javase/6/docs/api/java/util/Map.html" title="class or interface in java.util"><CODE>Map</CODE></A> that associates a raw type with an
     instance of that type.
 </dl>

 <h2>Collection Implementations</h2>

 <h3>of <A HREF="http://java.sun.com/javase/6/docs/api/java/util/List.html" title="class or interface in java.util"><CODE>List</CODE></A></h3>
 <dl>
 <dt><A HREF="../../../../com/google/common/collect/ImmutableList.html" title="class in com.google.common.collect"><CODE>ImmutableList</CODE></A>
 </ul>

 <h3>of <A HREF="http://java.sun.com/javase/6/docs/api/java/util/Set.html" title="class or interface in java.util"><CODE>Set</CODE></A></h3>
 <dl>
 <dt><A HREF="../../../../com/google/common/collect/ImmutableSet.html" title="class in com.google.common.collect"><CODE>ImmutableSet</CODE></A>
 </ul>

 <h3>of <A HREF="http://java.sun.com/javase/6/docs/api/java/util/SortedSet.html" title="class or interface in java.util"><CODE>SortedSet</CODE></A></h3>
 <dl>
 <dt><A HREF="../../../../com/google/common/collect/ImmutableSortedSet.html" title="class in com.google.common.collect"><CODE>ImmutableSortedSet</CODE></A>
 </dl>

 <h3>of <A HREF="http://java.sun.com/javase/6/docs/api/java/util/Map.html" title="class or interface in java.util"><CODE>Map</CODE></A></h3>
 <dl>
 <dt><A HREF="../../../../com/google/common/collect/ImmutableMap.html" title="class in com.google.common.collect"><CODE>ImmutableMap</CODE></A>
 <dt><A HREF="../../../../com/google/common/collect/ReferenceMap.html" title="class in com.google.common.collect"><CODE>ReferenceMap</CODE></A>
 </ul>

 <h3>of <A HREF="../../../../com/google/common/collect/BiMap.html" title="interface in com.google.common.collect"><CODE>BiMap</CODE></A></h3>
 <dl>
 <dt><A HREF="../../../../com/google/common/collect/HashBiMap.html" title="class in com.google.common.collect"><CODE>HashBiMap</CODE></A>
 <dt><A HREF="../../../../com/google/common/collect/EnumBiMap.html" title="class in com.google.common.collect"><CODE>EnumBiMap</CODE></A>
 <dt><A HREF="../../../../com/google/common/collect/EnumHashBiMap.html" title="class in com.google.common.collect"><CODE>EnumHashBiMap</CODE></A>
 </dl>

 <h3>of <A HREF="../../../../com/google/common/collect/Multiset.html" title="interface in com.google.common.collect"><CODE>Multiset</CODE></A></h3>
 <dl>
 <dt><A HREF="../../../../com/google/common/collect/ConcurrentMultiset.html" title="class in com.google.common.collect"><CODE>ConcurrentMultiset</CODE></A>
 <dt><A HREF="../../../../com/google/common/collect/EnumMultiset.html" title="class in com.google.common.collect"><CODE>EnumMultiset</CODE></A>
 <dt><A HREF="../../../../com/google/common/collect/HashMultiset.html" title="class in com.google.common.collect"><CODE>HashMultiset</CODE></A>
 <dt><A HREF="../../../../com/google/common/collect/ImmutableMultiset.html" title="class in com.google.common.collect"><CODE>ImmutableMultiset</CODE></A>
 <dt><A HREF="../../../../com/google/common/collect/LinkedHashMultiset.html" title="class in com.google.common.collect"><CODE>LinkedHashMultiset</CODE></A>
 <dt><A HREF="../../../../com/google/common/collect/TreeMultiset.html" title="class in com.google.common.collect"><CODE>TreeMultiset</CODE></A>
 </dl>

 <h3>of <A HREF="../../../../com/google/common/collect/Multimap.html" title="interface in com.google.common.collect"><CODE>Multimap</CODE></A></h3>
 <dl>
 <dt><A HREF="../../../../com/google/common/collect/ArrayListMultimap.html" title="class in com.google.common.collect"><CODE>ArrayListMultimap</CODE></A>
 <dt><A HREF="../../../../com/google/common/collect/HashMultimap.html" title="class in com.google.common.collect"><CODE>HashMultimap</CODE></A>
 <dt><A HREF="../../../../com/google/common/collect/ImmutableMultimap.html" title="class in com.google.common.collect"><CODE>ImmutableMultimap</CODE></A>
 <dt><A HREF="../../../../com/google/common/collect/LinkedHashMultimap.html" title="class in com.google.common.collect"><CODE>LinkedHashMultimap</CODE></A>
 <dt><A HREF="../../../../com/google/common/collect/TreeMultimap.html" title="class in com.google.common.collect"><CODE>TreeMultimap</CODE></A>
 </dl>

 <h2>Skeletal implementations</h2>
 <dl>
 <dt><A HREF="../../../../com/google/common/collect/AbstractIterator.html" title="class in com.google.common.collect"><CODE>AbstractIterator</CODE></A>
 <dt><A HREF="../../../../com/google/common/collect/AbstractIterable.html" title="class in com.google.common.collect"><CODE>AbstractIterable</CODE></A>
 <dt><A HREF="../../../../com/google/common/collect/AbstractMapEntry.html" title="class in com.google.common.collect"><CODE>AbstractMapEntry</CODE></A>
 <dt><A HREF="../../../../com/google/common/collect/AbstractMultiset.html" title="class in com.google.common.collect"><CODE>AbstractMultiset</CODE></A>
 <dt><A HREF="../../../../com/google/common/collect/AbstractMultisetEntry.html" title="class in com.google.common.collect"><CODE>AbstractMultisetEntry</CODE></A>
 <dt><A HREF="../../../../com/google/common/collect/AbstractRemovableIterator.html" title="class in com.google.common.collect"><CODE>AbstractRemovableIterator</CODE></A>
 <dt><A HREF="../../../../com/google/common/collect/UnmodifiableIterator.html" title="class in com.google.common.collect"><CODE>UnmodifiableIterator</CODE></A>
 </dl>

 <h2>Classes of static utility methods</h2>

 <dl>
 <dt><A HREF="../../../../com/google/common/collect/Collections2.html" title="class in com.google.common.collect"><CODE>Collections2</CODE></A>
 <dt><A HREF="../../../../com/google/common/collect/Iterators.html" title="class in com.google.common.collect"><CODE>Iterators</CODE></A>
 <dt><A HREF="../../../../com/google/common/collect/Iterables.html" title="class in com.google.common.collect"><CODE>Iterables</CODE></A>
 <dt><A HREF="../../../../com/google/common/collect/Lists.html" title="class in com.google.common.collect"><CODE>Lists</CODE></A>
 <dt><A HREF="../../../../com/google/common/collect/Maps.html" title="class in com.google.common.collect"><CODE>Maps</CODE></A>
 <dt><A HREF="../../../../com/google/common/collect/Sets.html" title="class in com.google.common.collect"><CODE>Sets</CODE></A>
 <dt><A HREF="../../../../com/google/common/collect/Multisets.html" title="class in com.google.common.collect"><CODE>Multisets</CODE></A>
 <dt><A HREF="../../../../com/google/common/collect/Multimaps.html" title="class in com.google.common.collect"><CODE>Multimaps</CODE></A>
 <dt><A HREF="../../../../com/google/common/collect/ObjectArrays.html" title="class in com.google.common.collect"><CODE>ObjectArrays</CODE></A>
 <dt><A HREF="../../../../com/google/common/collect/PrimitiveArrays.html" title="class in com.google.common.collect"><CODE>PrimitiveArrays</CODE></A>
 <dt><A HREF="../../../../com/google/common/collect/Serialization.html" title="class in com.google.common.collect"><CODE>Serialization</CODE></A>
 </dl>

 <h2>Comparators</h2>
 <dl>
 <dt><A HREF="../../../../com/google/common/collect/Comparators.html" title="class in com.google.common.collect"><CODE>Comparators</CODE></A>
 <dt><A HREF="../../../../com/google/common/collect/Ordering.html" title="class in com.google.common.collect"><CODE>Ordering</CODE></A>
 </ul>

 <h2>Constraints</h2>

 <dt><A HREF="../../../../com/google/common/collect/Constraint.html" title="interface in com.google.common.collect"><CODE>Constraint</CODE></A>
 <dt><A HREF="../../../../com/google/common/collect/Constraints.html" title="class in com.google.common.collect"><CODE>Constraints</CODE></A>
 <dt><A HREF="../../../../com/google/common/collect/MapConstraint.html" title="interface in com.google.common.collect"><CODE>MapConstraint</CODE></A>
 <dt><A HREF="../../../../com/google/common/collect/MapConstraints.html" title="class in com.google.common.collect"><CODE>MapConstraints</CODE></A>

 <h2>Forwarding collections</h2>

 <dl>
 <dt><A HREF="../../../../com/google/common/collect/ForwardingCollection.html" title="class in com.google.common.collect"><CODE>ForwardingCollection</CODE></A>
 <dt><A HREF="../../../../com/google/common/collect/ForwardingConcurrentMap.html" title="class in com.google.common.collect"><CODE>ForwardingConcurrentMap</CODE></A>
 <dt><A HREF="../../../../com/google/common/collect/ForwardingIterator.html" title="class in com.google.common.collect"><CODE>ForwardingIterator</CODE></A>
 <dt><A HREF="../../../../com/google/common/collect/ForwardingList.html" title="class in com.google.common.collect"><CODE>ForwardingList</CODE></A>
 <dt><A HREF="../../../../com/google/common/collect/ForwardingListIterator.html" title="class in com.google.common.collect"><CODE>ForwardingListIterator</CODE></A>
 <dt><A HREF="../../../../com/google/common/collect/ForwardingMap.html" title="class in com.google.common.collect"><CODE>ForwardingMap</CODE></A>
 <dt><A HREF="../../../../com/google/common/collect/ForwardingMapEntry.html" title="class in com.google.common.collect"><CODE>ForwardingMapEntry</CODE></A>
 <dt><A HREF="../../../../com/google/common/collect/ForwardingMultimap.html" title="class in com.google.common.collect"><CODE>ForwardingMultimap</CODE></A>
 <dt><A HREF="../../../../com/google/common/collect/ForwardingMultiset.html" title="class in com.google.common.collect"><CODE>ForwardingMultiset</CODE></A>
 <dt><A HREF="../../../../com/google/common/collect/ForwardingObject.html" title="class in com.google.common.collect"><CODE>ForwardingObject</CODE></A>
 <dt><A HREF="../../../../com/google/common/collect/ForwardingQueue.html" title="class in com.google.common.collect"><CODE>ForwardingQueue</CODE></A>
 <dt><A HREF="../../../../com/google/common/collect/ForwardingSet.html" title="class in com.google.common.collect"><CODE>ForwardingSet</CODE></A>
 <dt><A HREF="../../../../com/google/common/collect/ForwardingSortedMap.html" title="class in com.google.common.collect"><CODE>ForwardingSortedMap</CODE></A>
 <dt><A HREF="../../../../com/google/common/collect/ForwardingSortedSet.html" title="class in com.google.common.collect"><CODE>ForwardingSortedSet</CODE></A>
 </dl>

 <h2>Common Behavior</h2>

 <p>The methods of this package always throw <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/NullPointerException.html" title="class or interface in java.lang"><CODE>NullPointerException</CODE></A> in response to a null value being supplied
 for any parameter that is not explicitly annotated as being <A HREF="../../../../com/google/common/base/Nullable.html" title="annotation in com.google.common.base"><CODE>@Nullable</CODE></A>.
<P>

<P>
<DL>
<DT><B>Author:</B></DT>
  <DD>Mike Bostock, Kevin Bourrillion, Jared Levy</DD>
</DL>
<HR>


<!-- ======= START OF BOTTOM NAVBAR ====== -->
<A NAME="navbar_bottom"><!-- --></A>
<A HREF="#skip-navbar_bottom" title="Skip navigation links"></A>
<TABLE BORDER="0" WIDTH="100%" CELLPADDING="1" CELLSPACING="0" SUMMARY="">
<TR>
<TD COLSPAN=2 BGCOLOR="#EEEEFF" CLASS="NavBarCell1">
<A NAME="navbar_bottom_firstrow"><!-- --></A>
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="3" SUMMARY="">
  <TR ALIGN="center" VALIGN="top">
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../overview-summary.html"><FONT CLASS="NavBarFont1"><B>Overview</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#FFFFFF" CLASS="NavBarCell1Rev"> &nbsp;<FONT CLASS="NavBarFont1Rev"><B>Package</B></FONT>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <FONT CLASS="NavBarFont1">Class</FONT>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-tree.html"><FONT CLASS="NavBarFont1"><B>Tree</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../deprecated-list.html"><FONT CLASS="NavBarFont1"><B>Deprecated</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../index-all.html"><FONT CLASS="NavBarFont1"><B>Index</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../help-doc.html"><FONT CLASS="NavBarFont1"><B>Help</B></FONT></A>&nbsp;</TD>
  </TR>
</TABLE>
</TD>
<TD ALIGN="right" VALIGN="top" ROWSPAN=3><EM>
</EM>
</TD>
</TR>

<TR>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
&nbsp;<A HREF="../../../../com/google/common/base/package-summary.html"><B>PREV PACKAGE</B></A>&nbsp;
&nbsp;NEXT PACKAGE</FONT></TD>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
  <A HREF="../../../../index.html?com/google/common/collect/package-summary.html" target="_top"><B>FRAMES</B></A>  &nbsp;
&nbsp;<A HREF="package-summary.html" target="_top"><B>NO FRAMES</B></A>  &nbsp;
&nbsp;<SCRIPT type="text/javascript">
  <!--
  if(window==top) {
    document.writeln('<A HREF="../../../../allclasses-noframe.html"><B>All Classes</B></A>');
  }
  //-->
</SCRIPT>
<NOSCRIPT>
  <A HREF="../../../../allclasses-noframe.html"><B>All Classes</B></A>
</NOSCRIPT>


</FONT></TD>
</TR>
</TABLE>
<A NAME="skip-navbar_bottom"></A>
<!-- ======== END OF BOTTOM NAVBAR ======= -->

<HR>

</BODY>
</HTML>
